var express = require('express');
var path = require('path');
var favicon = require('serve-favicon');
var http = require('http');
var cookieParser = require('cookie-parser');
var bodyParser = require('body-parser');

var routes = require('./routes/'),
    ajax = require('./routes/ajax');

var app = express();

var server = http.createServer(app);
var publicPath = path.resolve(__dirname, '..', '..', 'public');

app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'ejs');

app.use(favicon(path.join(publicPath, 'favicon.ico')));
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({extended: false}));
app.use(cookieParser());
app.use(express.static(publicPath, {maxage: 1000 * 60 * 60 * 30}));

app.use('/', routes);
app.use(ajax);

app.use(function (req, res, next) {
    var err = new Error('Not Found');
    err.status = 404;
    next(err);
});

app.use(function (err, req, res, next) {
    res.status(err.status || 500);
    res.render('error', {
        message: err.message,
        error: {}
    });
});

module.exports = server;